
require 'dotnet'
reference 'System.Drawing'

module Ridge
  module Graphics
    class Bitmap < Image
      def initialize(rc, properties, data)
				super
				@filename = properties['file']
				if @filename then
					@bitmap = System::Drawing::Bitmap.new(@filename)
				elsif data then
					bin = System::Convert.fromBase64String(data)
					stream = System::IO::MemoryStream.new(bin)
					@bitmap = System::Drawing::Bitmap.new(stream)
				else
					w = 1
					h = 1
					w = Length.to_px(properties['width']) if properties['width']
					h = Length.to_px(properties['height']) if properties['height']
					@bitmap = System::Drawing::Bitmap.new(w, h)
				end
      end

      def native()
				@bitmap
      end
    end
    Images['bitmap'] = Bitmap

    class Icon < Image
      def initialize(rc, properties, data)
				@filename = properties['file']
				if @filename then
					@icon = System::Drawing::Icon.new(@filename)
				elsif data then
					bin = System::Convert.fromBase64String(data)
					stream = System::IO::MemoryStream.new(bin)
					@icon = System::Drawing::Icon.new(stream)
				else
					raise 'Can not create Icon'
				end
      end

      def native()
				@icon
      end
    end
    Images['icon'] = Icon
  end
end

