
module Ridge
	class REXMLResourceReader < ResourceReader
		def initialize(encoding='utf-8')
			super
			require 'rexml/document'
			if encoding and Ridge.encoding and encoding!=Ridge.encoding then
				require 'iconv'
				@conv = Iconv.new(Ridge.encoding, encoding)
			else
				@conv = nil
			end
		end

		def parse(stream)
			doc = REXML::Document.new(stream.read())
			root = parse_element(doc.root, ResourceElementRoot)
		end

		def parse_element(elem, klass=ResourceElement)
			name = elem.name
			properties = {}
			if @conv then
				elem.attributes.each do |aname, val|
					properties[@conv.iconv(aname)] = @conv.iconv(val)
				end
			else
				properties = elem.attributes
			end
			children = []
			elem.elements.each do |child|
				children.push(parse_element(child))
			end
			texts = []
			elem.texts.each do |text|
				if @conv then
					texts.push(@conv.iconv(text.value))
				else
					texts.push(text.value)
				end
			end
			return klass.new(name, properties, children, texts)
		end
	end
	Resource::Reader['xml'] = REXMLResourceReader
end

